-- VHDL Entity Board.FPGA_stepperMotorController.symbol
--
-- Created:
--          by - francois.UNKNOWN (WE3673)
--          at - 10:50:35 12.08.2013
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
   USE ieee.std_logic_1164.all;
   USE ieee.numeric_std.all;

ENTITY FPGA_stepperMotorController IS
   GENERIC( 
      ioBitNb   : positive := 13;
      jtagBitNb : positive := 3
   );
   PORT( 
      clock   : IN     std_ulogic;
      reset_n : IN     std_uLogic;
      sCl     : IN     std_logic;
      jtagIo  : OUT    std_ulogic_vector (1 TO jtagBitNb);
      I_O     : INOUT  std_logic_vector (1 TO ioBitNb);
      sDa     : INOUT  std_logic
   );

-- Declarations

END FPGA_stepperMotorController ;





-- VHDL Entity StepperMotor.stepperMotorController.symbol
--
-- Created:
--          by - francois.UNKNOWN (WE3673)
--          at - 10:48:57 12.08.2013
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.all;

ENTITY stepperMotorController IS
   GENERIC( 
      i2cBitNb               : positive := 10;
      prescalerBitNb         : positive := 16;
      testPrescalerBitNb     : positive := 10;
      angleBitNb             : positive := 4;
      hwOrientationBitNb     : positive := 3;
      baseAddress            : natural  := 0;
      orientationBaseAddress : natural  := 8;
      testBitNb              : positive := 8
   );
   PORT( 
      clock      : IN     std_ulogic;
      reset      : IN     std_ulogic;
      sClIn      : IN     std_uLogic;
      sDaIn      : IN     std_uLogic;
      stepperEnd : IN     std_ulogic;
      testMode   : IN     std_ulogic;
      coil1      : OUT    std_ulogic;
      coil2      : OUT    std_ulogic;
      coil3      : OUT    std_ulogic;
      coil4      : OUT    std_ulogic;
      sDaOut     : OUT    std_uLogic;
      testOut    : OUT    std_ulogic_vector (1 TO testBitNb)
   );

-- Declarations

END stepperMotorController ;





LIBRARY ieee;
USE ieee.std_logic_1164.all;

PACKAGE gates IS

  constant gateDelay: time := 1 ns;
--  constant gateDelay: time := 0.1 ns;

END gates;




-- VHDL Entity gates.or2.symbol
--
-- Created:
--          by - francois.UNKNOWN (WE3673)
--          at - 15:55:45 25.06.2013
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
-- LIBRARY gates;
  use work.gates.all;

ENTITY or2 IS
   GENERIC( 
      delay : time := gateDelay
   );
   PORT( 
      in1  : IN     std_uLogic;
      in2  : IN     std_uLogic;
      out1 : OUT    std_uLogic
   );

-- Declarations

END or2 ;





ARCHITECTURE sim OF or2 IS
BEGIN
  out1 <= in1 or in2 after delay;
END ARCHITECTURE sim;





-- VHDL Entity StepperMotor.angleControl.symbol
--
-- Created:
--          by - francois.UNKNOWN (WE3673)
--          at - 10:48:57 12.08.2013
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.all;

ENTITY angleControl IS
   GENERIC( 
      angleNbBits : positive := 8
   );
   PORT( 
      clock      : IN     std_uLogic;
      clockwise  : IN     std_uLogic;
      enStep     : IN     std_uLogic;
      reset      : IN     std_uLogic;
      restart    : IN     std_ulogic;
      sensorLeft : IN     std_uLogic;
      stepperEnd : IN     std_uLogic;
      target     : IN     unsigned (angleNbBits-1 DOWNTO 0);
      actual     : OUT    unsigned (angleNbBits-1 DOWNTO 0);
      coil1      : OUT    std_ulogic;
      coil2      : OUT    std_uLogic;
      coil3      : OUT    std_uLogic;
      coil4      : OUT    std_uLogic;
      reached    : OUT    std_ulogic
   );

-- Declarations

END angleControl ;





-- VHDL Entity StepperMotor.stepperCounter.symbol
--
-- Created:
--          by - francois.UNKNOWN (WE3673)
--          at - 10:48:57 12.08.2013
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.all;

ENTITY stepperCounter IS
   GENERIC( 
      angleNbBits : positive := 16
   );
   PORT( 
      clock         : IN     std_ulogic;
      enCoils       : IN     std_ulogic;
      incCount      : IN     std_ulogic;
      reset         : IN     std_ulogic;
      step          : IN     std_ulogic;
      stepperEnd    : IN     std_ulogic;
      motorPosition : OUT    unsigned (angleNbBits-1 DOWNTO 0)
   );

-- Declarations

END stepperCounter ;





ARCHITECTURE RTL OF stepperCounter IS

  signal sMotorPosition: unsigned(motorPosition'range);

BEGIN

  count: process(reset, clock)
  begin
    if reset = '1' then
      sMotorPosition <= (others => '0');
    elsif rising_edge(clock) then
      if stepperEnd = '1' then
        sMotorPosition <= (others => '0');
      elsif (step = '1') and (enCoils = '1') then
        if incCount = '1' then
          sMotorPosition <= sMotorPosition + 1;
        else
          sMotorPosition <= sMotorPosition - 1;
        end if;
      end if;
    end if;
  end process count;

  motorPosition <= sMotorPosition;

END ARCHITECTURE RTL;




-- VHDL Entity sequential.DFFE.symbol
--
-- Created:
--          by - francois.UNKNOWN (WE3673)
--          at - 15:55:45 25.06.2013
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
-- LIBRARY gates;
  use work.gates.all;

ENTITY DFFE IS
   GENERIC( 
      delay : time := gateDelay
   );
   PORT( 
      CLK : IN     std_uLogic;
      CLR : IN     std_uLogic;
      D   : IN     std_uLogic;
      E   : IN     std_uLogic;
      Q   : OUT    std_uLogic
   );

-- Declarations

END DFFE ;





ARCHITECTURE sim OF DFFE IS
BEGIN

  process(clk, clr)
  begin
    if clr = '1' then
      q <= '0' after delay;
    elsif rising_edge(clk) then
      if e = '1' then
        q <= d after delay;
      end if;
    end if;
  end process;

END ARCHITECTURE sim;





-- VHDL Entity StepperMotor.angleDifference.symbol
--
-- Created:
--          by - francois.UNKNOWN (WE3673)
--          at - 10:48:57 12.08.2013
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.all;

ENTITY angleDifference IS
   GENERIC( 
      angleNbBits : positive := 16
   );
   PORT( 
      actualPosition : IN     unsigned (angleNbBits-1 DOWNTO 0);
      clock          : IN     std_ulogic;
      reset          : IN     std_ulogic;
      restart        : IN     std_ulogic;
      stepperEnd     : IN     std_ulogic;
      targetPosition : IN     unsigned (angleNbBits-1 DOWNTO 0);
      enCoils        : OUT    std_ulogic;
      incAngle       : OUT    std_ulogic;
      reached        : OUT    std_ulogic
   );

-- Declarations

END angleDifference ;





ARCHITECTURE RTL OF angleDifference IS

  signal initDone: std_ulogic;

  signal difference: signed(targetPosition'high+1 downto 0);
  signal reached_int: std_ulogic;

BEGIN

  difference <= signed(resize(targetPosition, difference'length) - actualPosition);

  reached_int <= '1' when abs(difference) <= 1 else '0';
  reached <= reached_int;

--  incAngle <= '0' when (initDone = '0') or (difference < 0) else '1';
  chooseDirection: process(initDone, difference)
  begin
    if initDone = '0' then
      incAngle <= '0';
    else -- initDone = '1'
      if difference >= 0 then
        incAngle <= '1';
      else
        incAngle <= '0';
      end if;
    end if;
  end process chooseDirection;

  enCoils <= '1' when (initDone = '0') or (reached_int = '0') else '0';

  goToZero: process(reset, clock)
  begin
    if reset = '1' then
      initDone <= '0';
    elsif rising_edge(clock) then
      if restart = '1' then
        initDone <= '0';
      elsif stepperEnd = '1' then
        initDone <= '1';
      end if;
    end if;
  end process goToZero;

END ARCHITECTURE RTL;




-- VHDL Entity StepperMotor.coilControl.symbol
--
-- Created:
--          by - francois.UNKNOWN (WE3673)
--          at - 10:48:57 12.08.2013
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.all;

ENTITY coilControl IS
   PORT( 
      clock   : IN     std_ulogic;
      dir1to4 : IN     std_ulogic;
      enCoils : IN     std_ulogic;
      reset   : IN     std_ulogic;
      step    : IN     std_ulogic;
      coil1   : OUT    std_ulogic;
      coil2   : OUT    std_uLogic;
      coil3   : OUT    std_uLogic;
      coil4   : OUT    std_uLogic
   );

-- Declarations

END coilControl ;





ARCHITECTURE RTL OF coilControl IS

  signal phaseCounter: unsigned(1 downto 0);

BEGIN

  countPhases: process(reset, clock)
  begin
    if reset = '1' then
      phaseCounter <= (others => '0');
    elsif rising_edge(clock) then
      if (enCoils = '1') and (step = '1') then
        if dir1to4 = '1' then
          phaseCounter <= phaseCounter + 1;
        else
          phaseCounter <= phaseCounter - 1;
        end if;
      end if;
    end if;
  end process countPhases;

  driveCoils: process(enCoils, phaseCounter)
  begin
    coil1 <= '0';
    coil2 <= '0';
    coil3 <= '0';
    coil4 <= '0';
    if enCoils = '1' then
      case to_integer(phaseCounter) is
        when 0 => coil1 <= '1';
        when 1 => coil2 <= '1';
        when 2 => coil3 <= '1';
        when 3 => coil4 <= '1';
        when others => null;
      end case;
    end if; 
  end process driveCoils;

END ARCHITECTURE RTL;




--
-- VHDL Architecture StepperMotor.angleControl.struct
--
-- Created:
--          by - francois.UNKNOWN (WE3673)
--          at - 10:48:58 12.08.2013
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.all;
-- LIBRARY gates;
  use work.gates.all;

-- LIBRARY sequential;
-- LIBRARY StepperMotor;

ARCHITECTURE struct OF angleControl IS

   -- Architecture declarations

   -- Internal signal declarations
   SIGNAL dir1to4      : std_ulogic;
   SIGNAL enCoils      : std_ulogic;
   SIGNAL enCoilsSynch : std_ulogic;
   SIGNAL incAngle     : std_ulogic;

   -- Implicit buffer signal declarations
   SIGNAL actual_internal : unsigned (angleNbBits-1 DOWNTO 0);


   -- Component Declarations
   COMPONENT DFFE
   GENERIC (
      delay : time := gateDelay
   );
   PORT (
      CLK : IN     std_uLogic ;
      CLR : IN     std_uLogic ;
      D   : IN     std_uLogic ;
      E   : IN     std_uLogic ;
      Q   : OUT    std_uLogic 
   );
   END COMPONENT;
   COMPONENT angleDifference
   GENERIC (
      angleNbBits : positive := 16
   );
   PORT (
      actualPosition : IN     unsigned (angleNbBits-1 DOWNTO 0);
      clock          : IN     std_ulogic ;
      reset          : IN     std_ulogic ;
      restart        : IN     std_ulogic ;
      stepperEnd     : IN     std_ulogic ;
      targetPosition : IN     unsigned (angleNbBits-1 DOWNTO 0);
      enCoils        : OUT    std_ulogic ;
      incAngle       : OUT    std_ulogic ;
      reached        : OUT    std_ulogic 
   );
   END COMPONENT;
   COMPONENT coilControl
   PORT (
      clock   : IN     std_ulogic ;
      dir1to4 : IN     std_ulogic ;
      enCoils : IN     std_ulogic ;
      reset   : IN     std_ulogic ;
      step    : IN     std_ulogic ;
      coil1   : OUT    std_ulogic ;
      coil2   : OUT    std_uLogic ;
      coil3   : OUT    std_uLogic ;
      coil4   : OUT    std_uLogic 
   );
   END COMPONENT;
   COMPONENT stepperCounter
   GENERIC (
      angleNbBits : positive := 16
   );
   PORT (
      clock         : IN     std_ulogic ;
      enCoils       : IN     std_ulogic ;
      incCount      : IN     std_ulogic ;
      reset         : IN     std_ulogic ;
      step          : IN     std_ulogic ;
      stepperEnd    : IN     std_ulogic ;
      motorPosition : OUT    unsigned (angleNbBits-1 DOWNTO 0)
   );
   END COMPONENT;

   -- Optional embedded configurations
   -- pragma synthesis_off
--    FOR ALL : DFFE USE ENTITY sequential.DFFE;
--    FOR ALL : angleDifference USE ENTITY StepperMotor.angleDifference;
--    FOR ALL : coilControl USE ENTITY StepperMotor.coilControl;
--    FOR ALL : stepperCounter USE ENTITY StepperMotor.stepperCounter;
   -- pragma synthesis_on


BEGIN
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 1 eb1
   dir1to4 <= incAngle xor clockwise xor sensorLeft;


   -- Instance port mappings.
   I_DFFE : DFFE
      GENERIC MAP (
         delay => gateDelay
      )
      PORT MAP (
         CLK => clock,
         CLR => reset,
         D   => enCoils,
         E   => enStep,
         Q   => enCoilsSynch
      );
   I_diff : angleDifference
      GENERIC MAP (
         angleNbBits => angleNbBits
      )
      PORT MAP (
         actualPosition => actual_internal,
         clock          => clock,
         reset          => reset,
         restart        => restart,
         stepperEnd     => stepperEnd,
         targetPosition => target,
         enCoils        => enCoils,
         incAngle       => incAngle,
         reached        => reached
      );
   I_phases : coilControl
      PORT MAP (
         clock   => clock,
         dir1to4 => dir1to4,
         enCoils => enCoilsSynch,
         reset   => reset,
         step    => enStep,
         coil1   => coil1,
         coil2   => coil2,
         coil3   => coil3,
         coil4   => coil4
      );
   I_cnt : stepperCounter
      GENERIC MAP (
         angleNbBits => angleNbBits
      )
      PORT MAP (
         clock         => clock,
         enCoils       => enCoilsSynch,
         incCount      => incAngle,
         reset         => reset,
         step          => enStep,
         stepperEnd    => stepperEnd,
         motorPosition => actual_internal
      );

   -- Implicit buffered output assignments
   actual <= actual_internal;

END struct;




-- VHDL Entity StepperMotor.stepperMotorPrescaler.symbol
--
-- Created:
--          by - francois.UNKNOWN (WE3673)
--          at - 10:48:58 12.08.2013
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.all;

ENTITY stepperMotorPrescaler IS
   GENERIC( 
      prescalerBitNb     : positive := 16;
      testPrescalerBitNb : positive := 10
   );
   PORT( 
      clock     : IN     std_ulogic;
      reset     : IN     std_ulogic;
      pwmEn     : OUT    std_ulogic;
      prescaler : IN     unsigned (prescalerBitNb-1 DOWNTO 0);
      testMode  : IN     std_ulogic
   );

-- Declarations

END stepperMotorPrescaler ;





ARCHITECTURE RTL OF stepperMotorPrescaler IS

  signal testPrescalerCounter: unsigned(testPrescalerbitNb-1 downto 0);
  signal testPrescalerDone: std_ulogic;

  signal prescalerCounter: unsigned(prescaler'range);
  signal prescalerDone: std_ulogic;

BEGIN
  ------------------------------------------------------------------------------
                                                  -- test mode presacler counter
  testDivide: process(reset, clock)
  begin
    if reset = '1' then
      testPrescalerCounter <= (others => '0');
    elsif rising_edge(clock) then
      testPrescalerCounter <= testPrescalerCounter + 1;
    end if;
  end process testDivide;

  testPrescalerDone <= '1' when testMode = '0'
    else '1' when testPrescalerCounter = 0
    else '0';

  ------------------------------------------------------------------------------
                                                            -- presacler counter
  prescalerDivide: process(reset, clock)
  begin
    if reset = '1' then
      prescalerCounter <= (others => '0');
    elsif rising_edge(clock) then
      if testPrescalerDone = '1' then
        if prescalerDone = '1' then
          prescalerCounter <= (others => '0');
        else
          prescalerCounter <= prescalerCounter + 1;
        end if;
      end if;
    end if;
  end process prescalerDivide;

  prescalerDone <= testPrescalerDone when prescalerCounter+1 >= prescaler
    else '0';
  pwmEn <= prescalerDone;

END ARCHITECTURE RTL;




-- VHDL Entity I2C.i2cTransceiver.symbol
--
-- Created:
--          by - francois.UNKNOWN (WE3673)
--          at - 10:09:34 09.08.2013
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.all;

ENTITY i2cTransceiver IS
   GENERIC( 
      dataBitNb : positive := 8
   );
   PORT( 
      sDaIn     : IN     std_ulogic;
      clock     : IN     std_ulogic;
      reset     : IN     std_ulogic;
      dataIn    : OUT    std_ulogic_vector (dataBitNb-2-1 DOWNTO 0);
      dataValid : OUT    std_ulogic;
      sCl       : IN     std_ulogic;
      addr      : OUT    unsigned (dataBitNb-3-1 DOWNTO 0);
      writeData : OUT    std_ulogic;
      sDaOut    : OUT    std_ulogic;
      dataOut   : IN     std_ulogic_vector (dataBitNb-2-1 DOWNTO 0)
   );

-- Declarations

END i2cTransceiver ;





PACKAGE CommonLib IS

  function requiredBitNb (val : integer) return integer;

END CommonLib;




PACKAGE BODY CommonLib IS

  function requiredBitNb (val : integer) return integer is
    variable powerOfTwo, bitNb : integer;
  begin
    powerOfTwo := 1;
    bitNb := 0;
    while powerOfTwo <= val loop
      powerOfTwo := 2 * powerOfTwo;
      bitNb := bitNb + 1;
    end loop;
    return bitNb;
  end requiredBitNb;

END CommonLib;




-- library Common;
  use work.CommonLib.all;

architecture RTL of i2cTransceiver is
                                                                     -- receiver
  signal clDelayed      : std_uLogic;
  signal daDelayed      : std_uLogic;
  signal clRising       : std_uLogic;
  signal clFalling      : std_uLogic;
  signal daRising       : std_uLogic;
  signal daFalling      : std_uLogic;
  signal startCondition : std_uLogic;
  signal stopCondition  : std_uLogic;
  signal bitCounter     : unsigned(requiredBitNb(dataBitNb)-1 downto 0);
  signal inputShiftReg  : std_ulogic_vector(dataBitNb-2 downto 0);
  signal clRisingDelayed: std_uLogic;
  signal endOfWord      : std_uLogic;
  signal i2cDataValid   : std_uLogic;
  signal i2cData        : std_ulogic_vector(inputShiftReg'high+1 downto 0);
                                                                      -- decoder
  type   rxStateType    is (idle, readAddress, incAddress);
  signal rxState        : rxStateType;
  signal rxAddress      : unsigned(addr'range);
  signal writeMode      : std_uLogic;

  signal loadOutShiftReg: std_uLogic;
  signal enSdaOut       : std_uLogic;
  signal outputShiftReg : std_ulogic_vector(dataBitNb-2-1 downto 0);

begin
  --============================================================================
                                             -- start, stop and other conditions
  delayInputs: process(reset, clock)
  begin
    if reset = '1' then
      clDelayed <= '1';
      daDelayed <= '1';
      clRisingDelayed <= '0';
    elsif rising_edge(clock) then
      clDelayed <= sCl;
      daDelayed <= sDaIn;
      clRisingDelayed <= clRising;
    end if;
  end process delayInputs;

  clRising <= '1' when (sCl = '1') and (clDelayed = '0') else '0';
  clFalling <= '1' when (sCl = '0') and (clDelayed = '1') else '0';
  daRising <= '1' when (sDaIn = '1') and (daDelayed = '0') else '0';
  daFalling <= '1' when (sDaIn = '0') and (daDelayed = '1') else '0';
  startCondition <= '1' when (daFalling = '1') and (sCl = '1') else '0';
  stopCondition <= '1' when (daRising = '1') and (sCl = '1') else '0';

  ------------------------------------------------------------------------------
                                                                  -- bit counter
  countBitNb: process(reset, clock)
  begin
    if reset = '1' then
      bitCounter <= (others => '0');
    elsif rising_edge(clock) then
      if startCondition = '1' then
        bitCounter <= (others => '0');
      elsif stopCondition = '1' then
        bitCounter <= (others => '0');
      elsif clRising = '1' then
        if bitCounter <= dataBitNb then
          bitCounter <= bitCounter + 1;
        else
          bitCounter <= (others => '0');
        end if;
      elsif endOfWord = '1' then
        bitCounter <= (others => '0');
      end if;
    end if;
  end process countBitNb;

  endOfWord <= '1' when (clRisingDelayed = '1') and (bitCounter = dataBitNb-1)
    else '0';

  ------------------------------------------------------------------------------
                                                         -- input shift register
  shiftInputBits: process(reset, clock)
  begin
    if reset = '1' then
      inputShiftReg <= (others => '0');
    elsif rising_edge(clock) then
      if clRising = '1' then
        inputShiftReg(inputShiftReg'high downto 1) <= inputShiftReg(inputShiftReg'high-1 downto 0);
        inputShiftReg(0) <= sDaIn;
      end if;
    end if;
  end process shiftInputBits;

  ------------------------------------------------------------------------------
               -- generate data and control
               -- start and stop: MSB is '1', LSB specifies start/stop
               -- data words: MSB is '0', 8 next bytes are data word, LSB is ack
               -- could be made combinatorial, but sequential is easier to debug
  getWord: process(reset, clock)
  begin
    if reset = '1' then
      i2cDataValid <= '0';
      i2cData <= (others => '0');
    elsif rising_edge(clock) then
      i2cDataValid <= '0';
      if startCondition = '1' then
        i2cDataValid <= '1';
        i2cData <= (others => '0');
        i2cData(i2cData'high) <= '1';
      elsif stopCondition = '1' then
        i2cDataValid <= '1';
        i2cData <= (others => '0');
        i2cData(i2cData'high) <= '1';
        i2cData(0) <= '1';
      elsif endOfWord = '1' then
        i2cDataValid <= '1';
        i2cData <= '0' & inputShiftReg;
      end if;
    end if;
  end process getWord;

  --============================================================================
                                                  -- address and data extraction
  rxFsm: process(reset, clock)
  begin
    if reset = '1' then
      rxState <= idle;
    elsif rising_edge(clock) then
      if stopCondition = '1' then
        rxState <= idle;
      elsif i2cDataValid = '1' then
        case rxState is
          when idle =>
                                         -- to readAddress after start condition
            if (i2cData(i2cData'high) = '1') and (i2cData(0) = '0') then
              rxState <= readAddress;
            end if;
          when readAddress =>
                                              -- to incAddress after readAddress
            rxState <= incAddress;
          when incAddress =>
            rxState <= incAddress;
--            if (i2cData(i2cData'high) = '1') and (i2cData(0) = '1') then
--              rxState <= idle;
--            end if;
        end case;
      end if;
    end if;
  end process rxFsm;

  dataValid <= i2cDataValid and not(i2cData(i2cData'high))
    when rxState = incAddress
    else '0';
  dataIn <= i2cData(dataIn'high+1 downto 1);

  ------------------------------------------------------------------------------
                                                  -- provide running i2c address
  updateAddress: process(reset, clock)
  begin
    if reset = '1' then
      rxAddress <= (others => '0');
      writeMode <= '0';
    elsif rising_edge(clock) then
      if i2cDataValid = '1' then
        case rxState is
          when readAddress =>
            rxAddress <= resize(shift_right(unsigned(i2cData), 2), rxAddress'length);
            writeMode <= not i2cData(1); -- i2cData(1)=0 -> master write to slave
          when incAddress =>
            rxAddress <= rxAddress + 1;
          when others => null;
        end case;
      end if;
    end if;
  end process updateAddress;

  addr <= rxAddress;
  writeData <= writeMode;

  --============================================================================
                                                              -- output controls
  controlAnswering: process(reset, clock)
  begin
    if reset = '1' then
      loadOutShiftReg <= '0';
      enSdaOut <= '0';
    elsif rising_edge(clock) then
      if endOfWord = '1' then
        loadOutShiftReg <= '1';
      elsif clRising = '1' then
        loadOutShiftReg <= '0';
      end if;
      if (bitCounter = 0) and (rxState = incAddress) and (writeMode = '0') then
        if sDaIn /= '0' then
          enSdaOut <= '1';
        end if;
      elsif ( (bitCounter = 8) and (clFalling = '1') ) or (rxState = idle) then
        enSdaOut <= '0';
      end if;
    end if;
  end process controlAnswering;

  ------------------------------------------------------------------------------
                                                        -- output shift register
  shiftOutputBits: process(reset, clock)
  begin
    if reset = '1' then
      outputShiftReg <= (others => '0');
    elsif rising_edge(clock) then
      if loadOutShiftReg = '1' then
        outputShiftReg <= (others => '1');
        outputShiftReg(dataOut'range) <= dataOut;
      elsif clFalling = '1' then
        outputShiftReg(outputShiftReg'high downto 1) <= outputShiftReg(outputShiftReg'high-1 downto 0);
        outputShiftReg(0) <= '0';
      end if;
    end if;
  end process shiftOutputBits;

  ------------------------------------------------------------------------------
                                                        -- reply to read request
  sDaOut <= outputShiftReg(outputShiftReg'high) when enSdaOut = '1'
    else '1';

end RTL;




-- VHDL Entity StepperMotor.stepperMotorRegisters.symbol
--
-- Created:
--          by - francois.UNKNOWN (WE3673)
--          at - 10:48:58 12.08.2013
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.all;

ENTITY stepperMotorRegisters IS
   GENERIC( 
      busAddressBitNb        : positive := 8;
      busDataBitNb           : positive := 8;
      prescalerBitNb         : positive := 8;
      angleBitNb             : positive := 8;
      hwOrientationBitNb     : positive := 3;
      baseAddress            : natural  := 0;
      orientationBaseAddress : natural  := 8
   );
   PORT( 
      clock            : IN     std_ulogic;
      reset            : IN     std_ulogic;
      busDataIn        : IN     std_ulogic_vector (busDataBitNb-1 DOWNTO 0);
      writeRegs        : IN     std_ulogic;
      target           : OUT    unsigned (angleBitNb-1 DOWNTO 0);
      busAddress       : IN     unsigned (busAddressBitNb-1 DOWNTO 0);
      prescaler        : OUT    unsigned (prescalerBitNb-1 DOWNTO 0);
      en               : IN     std_ulogic;
      stepperEndBus    : OUT    std_ulogic;
      actual           : IN     unsigned (angleBitNb-1 DOWNTO 0);
      busDataOut       : OUT    std_ulogic_vector (busDataBitNb-1 DOWNTO 0);
      stepperEndSwitch : IN     std_ulogic;
      hwOrientation    : OUT    std_ulogic_vector (hwOrientationBitNb-1 DOWNTO 0);
      reached          : IN     std_ulogic;
      restart          : OUT    std_ulogic
   );

-- Declarations

END stepperMotorRegisters ;





ARCHITECTURE RTL OF stepperMotorRegisters IS

  constant prescalerBaseAddr: natural := baseAddress;
  constant angleBaseAddr    : natural := baseAddress + 2;
  constant stepperEndAddr   : natural := baseAddress;
  constant statusAddr       : natural := baseAddress;
  constant statusEndSwitchId: natural := 0;
  constant statusReachedId  : natural := 1;
  constant hwStepperEndId   : natural := 3;
  constant hwRestartId      : natural := 4;
  constant registerLength   : positive := 2*busDataIn'length;
  signal   prescaler_int    : unsigned(registerLength-1 downto 0);
  signal   target_int       : unsigned(registerLength-1 downto 0);
  signal   actualReg        : unsigned(registerLength-1 downto 0);
  signal   switchAddress    : unsigned(busAddress'range);
  signal   enDelayed        : std_ulogic;
  signal   stepperEndMaster : std_ulogic;
  signal   stepperEndSlave  : std_ulogic;

BEGIN
  ------------------------------------------------------------------------------
                                                         -- store bytes from I2C
  storeBytes: process(reset, clock)
  begin
    if reset = '1' then
      prescaler_int <= (others => '0');
      target_int <= (others => '0');
      hwOrientation <= (others => '0');
      stepperEndSlave <= '0';
      stepperEndMaster <= '0';
      restart <= '0';
    elsif rising_edge(clock) then
      if en = '1' then
                                                         -- controls from master
        if writeRegs = '1' then
          case to_integer(busAddress) is
            when prescalerBaseAddr =>
              prescaler_int(busDataIn'range) <= unsigned(busDataIn);
            when prescalerBaseAddr+1 =>
              prescaler_int(
                prescaler_int'high downto prescaler_int'length-busDataIn'length
              ) <= unsigned(busDataIn);
            when angleBaseAddr =>
              target_int(busDataIn'range) <= unsigned(busDataIn);
            when angleBaseAddr+1 =>
              target_int(
                target_int'high downto target_int'length-busDataIn'length
              ) <= unsigned(busDataIn);
            when angleBaseAddr+2 =>
              switchAddress <= unsigned(busDataIn(switchAddress'range));
            when orientationBaseAddress =>
              hwOrientation <= busDataIn(hwOrientation'range);
              stepperEndMaster <= busDataIn(hwStepperEndId);
              restart <= busDataIn(hwRestartId);
            when others => null;
          end case;
                                                   -- controls from other slaves
        else
          if busAddress = switchAddress then
            stepperEndSlave <= not busDataIn(0);
          end if;
        end if;
      end if;
    end if;
  end process storeBytes;

  stepperEndBus <= stepperEndSlave or stepperEndMaster;

  ------------------------------------------------------------------------------
                                                -- update data after second byte
  storeControls: process(reset, clock)
  begin
    if reset = '1' then
      enDelayed <= '0';
      prescaler <= (others => '0');
      target <= (others => '0');
    elsif rising_edge(clock) then
      enDelayed <= en;
      if enDelayed = '1' then
        if busAddress(0) = '0' then
          prescaler <= resize(prescaler_int, prescaler'length);
          target <= resize(target_int, target'length);
        end if;
      end if;
    end if;
  end process storeControls;

  --============================================================================
                                                        -- store actual position
  storeValues: process(reset, clock)
  begin
    if reset = '1' then
      actualReg <= (others => '0');
    elsif rising_edge(clock) then
      if busAddress = angleBaseAddr-1 then
        actualReg <= resize(actual, actualReg'length);
      end if;
    end if;
  end process storeValues;

  ------------------------------------------------------------------------------
                                                        -- multiplex data to I2C
  sendStatus: process(busAddress, actual)
  begin
    busdataOut <= (others => '1');
    case to_integer(busAddress) is
      when angleBaseAddr =>
        busdataOut <= std_ulogic_vector(actualReg(busdataOut'range));
      when angleBaseAddr+1 =>
        busdataOut <= std_ulogic_vector(
          actualReg(actualReg'high downto actualReg'length-busdataOut'length)
        );
      when statusAddr =>
        busdataOut(statusEndSwitchId) <= not(stepperEndSwitch);
        busdataOut(statusReachedId) <= reached;
      when others => null;
    end case;
  end process sendStatus;

END ARCHITECTURE RTL;




--
-- VHDL Architecture StepperMotor.stepperMotorController.struct
--
-- Created:
--          by - francois.UNKNOWN (WE3673)
--          at - 10:48:58 12.08.2013
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.all;
-- LIBRARY gates;
  use work.gates.all;

-- LIBRARY gates;
-- LIBRARY I2C;
-- LIBRARY StepperMotor;

ARCHITECTURE struct OF stepperMotorController IS

   -- Architecture declarations
   constant dataBitNb: positive := i2cBitNb-2;
   constant addressBitNb: positive := dataBitNb-1;

   -- Internal signal declarations
   SIGNAL actualAngle   : unsigned(angleBitNb-1 DOWNTO 0);
   SIGNAL addr          : unsigned(addressBitNb-1 DOWNTO 0);
   SIGNAL dataIn        : std_ulogic_vector(dataBitNb-1 DOWNTO 0);
   SIGNAL dataOut       : std_ulogic_vector(dataBitNb-1 DOWNTO 0);
   SIGNAL dataValid     : std_ulogic;
   SIGNAL hwOrientation : std_ulogic_vector(hwOrientationBitNb-1 DOWNTO 0);
   SIGNAL prescaler     : unsigned(prescalerBitNb-1 DOWNTO 0);
   SIGNAL reached       : std_ulogic;
   SIGNAL restart       : std_ulogic;
   SIGNAL stepEn        : std_ulogic;
   SIGNAL stepperEndBus : std_ulogic;
   SIGNAL stepperEndOr  : std_uLogic;
   SIGNAL targetAngle   : unsigned(angleBitNb-1 DOWNTO 0);
   SIGNAL writeRegs     : std_ulogic;


   -- Component Declarations
   COMPONENT or2
   GENERIC (
      delay : time := gateDelay
   );
   PORT (
      in1  : IN     std_uLogic ;
      in2  : IN     std_uLogic ;
      out1 : OUT    std_uLogic 
   );
   END COMPONENT;
   COMPONENT i2cTransceiver
   GENERIC (
      dataBitNb : positive := 8
   );
   PORT (
      sDaIn     : IN     std_ulogic ;
      clock     : IN     std_ulogic ;
      reset     : IN     std_ulogic ;
      dataIn    : OUT    std_ulogic_vector (dataBitNb-2-1 DOWNTO 0);
      dataValid : OUT    std_ulogic ;
      sCl       : IN     std_ulogic ;
      addr      : OUT    unsigned (dataBitNb-3-1 DOWNTO 0);
      writeData : OUT    std_ulogic ;
      sDaOut    : OUT    std_ulogic ;
      dataOut   : IN     std_ulogic_vector (dataBitNb-2-1 DOWNTO 0)
   );
   END COMPONENT;
   COMPONENT angleControl
   GENERIC (
      angleNbBits : positive := 8
   );
   PORT (
      clock      : IN     std_uLogic ;
      clockwise  : IN     std_uLogic ;
      enStep     : IN     std_uLogic ;
      reset      : IN     std_uLogic ;
      restart    : IN     std_ulogic ;
      sensorLeft : IN     std_uLogic ;
      stepperEnd : IN     std_uLogic ;
      target     : IN     unsigned (angleNbBits-1 DOWNTO 0);
      actual     : OUT    unsigned (angleNbBits-1 DOWNTO 0);
      coil1      : OUT    std_ulogic ;
      coil2      : OUT    std_uLogic ;
      coil3      : OUT    std_uLogic ;
      coil4      : OUT    std_uLogic ;
      reached    : OUT    std_ulogic 
   );
   END COMPONENT;
   COMPONENT stepperMotorPrescaler
   GENERIC (
      prescalerBitNb     : positive := 16;
      testPrescalerBitNb : positive := 10
   );
   PORT (
      clock     : IN     std_ulogic ;
      reset     : IN     std_ulogic ;
      pwmEn     : OUT    std_ulogic ;
      prescaler : IN     unsigned (prescalerBitNb-1 DOWNTO 0);
      testMode  : IN     std_ulogic 
   );
   END COMPONENT;
   COMPONENT stepperMotorRegisters
   GENERIC (
      busAddressBitNb        : positive := 8;
      busDataBitNb           : positive := 8;
      prescalerBitNb         : positive := 8;
      angleBitNb             : positive := 8;
      hwOrientationBitNb     : positive := 3;
      baseAddress            : natural  := 0;
      orientationBaseAddress : natural  := 8
   );
   PORT (
      clock            : IN     std_ulogic ;
      reset            : IN     std_ulogic ;
      busDataIn        : IN     std_ulogic_vector (busDataBitNb-1 DOWNTO 0);
      writeRegs        : IN     std_ulogic ;
      target           : OUT    unsigned (angleBitNb-1 DOWNTO 0);
      busAddress       : IN     unsigned (busAddressBitNb-1 DOWNTO 0);
      prescaler        : OUT    unsigned (prescalerBitNb-1 DOWNTO 0);
      en               : IN     std_ulogic ;
      stepperEndBus    : OUT    std_ulogic ;
      actual           : IN     unsigned (angleBitNb-1 DOWNTO 0);
      busDataOut       : OUT    std_ulogic_vector (busDataBitNb-1 DOWNTO 0);
      stepperEndSwitch : IN     std_ulogic ;
      hwOrientation    : OUT    std_ulogic_vector (hwOrientationBitNb-1 DOWNTO 0);
      reached          : IN     std_ulogic ;
      restart          : OUT    std_ulogic 
   );
   END COMPONENT;

   -- Optional embedded configurations
   -- pragma synthesis_off
--    FOR ALL : angleControl USE ENTITY StepperMotor.angleControl;
--    FOR ALL : i2cTransceiver USE ENTITY I2C.i2cTransceiver;
--    FOR ALL : or2 USE ENTITY gates.or2;
--    FOR ALL : stepperMotorPrescaler USE ENTITY StepperMotor.stepperMotorPrescaler;
--    FOR ALL : stepperMotorRegisters USE ENTITY StepperMotor.stepperMotorRegisters;
   -- pragma synthesis_on


BEGIN
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 1 eb1
   testOut <= (
     1 => stepperEndBus,
     2=> stepperEndOr,
     3 => stepEn,
     4 => reached,
     5 => hwOrientation(1),
     6 => hwOrientation(2),
     others => '0'
   );      


   -- Instance port mappings.
   I0 : or2
      GENERIC MAP (
         delay => gateDelay
      )
      PORT MAP (
         in1  => stepperEndBus,
         in2  => stepperEnd,
         out1 => stepperEndOr
      );
   I_i2c : i2cTransceiver
      GENERIC MAP (
         dataBitNb => i2cBitNb
      )
      PORT MAP (
         sDaIn     => sDaIn,
         clock     => clock,
         reset     => reset,
         dataIn    => dataIn,
         dataValid => dataValid,
         sCl       => sClIn,
         addr      => addr,
         writeData => writeRegs,
         sDaOut    => sDaOut,
         dataOut   => dataOut
      );
   I_angle : angleControl
      GENERIC MAP (
         angleNbBits => angleBitNb
      )
      PORT MAP (
         clock      => clock,
         clockwise  => hwOrientation(1),
         enStep     => stepEn,
         reset      => reset,
         restart    => restart,
         sensorLeft => hwOrientation(2),
         stepperEnd => stepperEndOr,
         target     => targetAngle,
         actual     => actualAngle,
         coil1      => coil1,
         coil2      => coil2,
         coil3      => coil3,
         coil4      => coil4,
         reached    => reached
      );
   I_div : stepperMotorPrescaler
      GENERIC MAP (
         prescalerBitNb     => prescalerBitNb,
         testPrescalerBitNb => testPrescalerBitNb
      )
      PORT MAP (
         clock     => clock,
         reset     => reset,
         pwmEn     => stepEn,
         prescaler => prescaler,
         testMode  => testMode
      );
   I_regs : stepperMotorRegisters
      GENERIC MAP (
         busAddressBitNb        => addressBitNb,
         busDataBitNb           => dataBitNb,
         prescalerBitNb         => prescalerBitNb,
         angleBitNb             => angleBitNb,
         hwOrientationBitNb     => hwOrientationBitNb,
         baseAddress            => baseAddress,
         orientationBaseAddress => orientationBaseAddress
      )
      PORT MAP (
         clock            => clock,
         reset            => reset,
         busDataIn        => dataIn,
         writeRegs        => writeRegs,
         target           => targetAngle,
         busAddress       => addr,
         prescaler        => prescaler,
         en               => dataValid,
         stepperEndBus    => stepperEndBus,
         actual           => actualAngle,
         busDataOut       => dataOut,
         stepperEndSwitch => stepperEnd,
         hwOrientation    => hwOrientation,
         reached          => reached,
         restart          => restart
      );

END struct;




-- VHDL Entity sequential.DFF.symbol
--
-- Created:
--          by - francois.UNKNOWN (WE3673)
--          at - 13:30:15 29.07.2013
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
-- LIBRARY gates;
  use work.gates.all;

ENTITY DFF IS
   GENERIC( 
      delay : time := 1 ns
   );
   PORT( 
      CLK : IN     std_uLogic;
      CLR : IN     std_uLogic;
      D   : IN     std_uLogic;
      Q   : OUT    std_uLogic
   );

-- Declarations

END DFF ;





ARCHITECTURE sim OF DFF IS
BEGIN

  process(clk, clr)
  begin
    if clr = '1' then
      q <= '0' after delay;
    elsif rising_edge(clk) then
      q <= d after delay;
    end if;
  end process;

END sim;




-- VHDL Entity gates.inverter.symbol
--
-- Created:
--          by - francois.UNKNOWN (WE3673)
--          at - 13:30:15 29.07.2013
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
-- LIBRARY gates;
  use work.gates.all;

ENTITY inverter IS
   GENERIC( 
      delay : time := 1 ns
   );
   PORT( 
      in1  : IN     std_uLogic;
      out1 : OUT    std_uLogic
   );

-- Declarations

END inverter ;





ARCHITECTURE sim OF inverter IS
BEGIN
  out1 <= NOT in1 after delay;
END sim;




-- VHDL Entity gates.logic1.symbol
--
-- Created:
--          by - francois.UNKNOWN (WE3673)
--          at - 13:30:15 29.07.2013
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
-- LIBRARY gates;
  use work.gates.all;

ENTITY logic1 IS
   PORT( 
      logic_1 : OUT    std_uLogic
   );

-- Declarations

END logic1 ;





ARCHITECTURE sim OF logic1 IS
BEGIN
  logic_1 <= '1';
END sim;




-- VHDL Entity gates.bufferUlogic.symbol
--
-- Created:
--          by - francois.UNKNOWN (WE3673)
--          at - 13:30:15 29.07.2013
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
-- LIBRARY gates;
  use work.gates.all;

ENTITY bufferUlogic IS
   GENERIC( 
      delay : time := gateDelay
   );
   PORT( 
      in1  : IN     std_uLogic;
      out1 : OUT    std_uLogic
   );

-- Declarations

END bufferUlogic ;





ARCHITECTURE sim OF bufferUlogic IS
BEGIN
  out1 <= in1 after delay;
END ARCHITECTURE sim;





--
-- VHDL Architecture Board.FPGA_stepperMotorController.struct
--
-- Created:
--          by - francois.UNKNOWN (WE3673)
--          at - 10:50:35 12.08.2013
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
   USE ieee.std_logic_1164.all;
   USE ieee.numeric_std.all;

-- LIBRARY gates;
   use work.gates.all;

-- LIBRARY gates;
-- LIBRARY sequential;
-- LIBRARY StepperMotor;

ARCHITECTURE struct OF FPGA_stepperMotorController IS

   -- Architecture declarations
   constant clockFrequency : real := 10.0E6;
   
   constant i2cBitNb : positive := 10;
   
   constant baseAddress: natural := 4;
   constant prescalerBitNb: positive := 16;
   constant testPrescalerBitNb: positive := 15;
   constant angleBitNb: positive := 16;
   
   constant orientationBaseAddress: natural := 10;
   constant hwOrientationBitNb : positive := 3;
   constant testOutBitNb : positive := 8;

   -- Internal signal declarations
   SIGNAL Q               : std_uLogic_vector(1 TO 2);
   SIGNAL coil1           : std_ulogic;
   SIGNAL coil2           : std_ulogic;
   SIGNAL coil3           : std_ulogic;
   SIGNAL coil4           : std_ulogic;
   SIGNAL logic_1         : std_uLogic;
   SIGNAL reset           : std_uLogic;
   SIGNAL resetSynch      : std_ulogic;
   SIGNAL resetSynch_n    : std_ulogic;
   SIGNAL sClSynch        : std_uLogic;
   SIGNAL sDaIn           : std_uLogic;
   SIGNAL sDaInSynch      : std_uLogic;
   SIGNAL sDaOut          : std_uLogic;
   SIGNAL stepperEnd      : std_uLogic;
   SIGNAL stepperEndSynch : std_uLogic;
   SIGNAL testMode        : std_uLogic;
   SIGNAL testModeSynch   : std_uLogic;
   SIGNAL testOut         : std_ulogic_vector(1 TO testOutBitNb);


   -- Component Declarations
   COMPONENT bufferUlogic
   GENERIC (
      delay : time := gateDelay
   );
   PORT (
      in1  : IN     std_uLogic ;
      out1 : OUT    std_uLogic 
   );
   END COMPONENT;
   COMPONENT inverter
   GENERIC (
      delay : time := 1 ns
   );
   PORT (
      in1  : IN     std_uLogic ;
      out1 : OUT    std_uLogic 
   );
   END COMPONENT;
   COMPONENT logic1
   PORT (
      logic_1 : OUT    std_uLogic 
   );
   END COMPONENT;
   COMPONENT DFF
   GENERIC (
      delay : time := 1 ns
   );
   PORT (
      CLK : IN     std_uLogic ;
      CLR : IN     std_uLogic ;
      D   : IN     std_uLogic ;
      Q   : OUT    std_uLogic 
   );
   END COMPONENT;
   COMPONENT stepperMotorController
   GENERIC (
      i2cBitNb               : positive := 10;
      prescalerBitNb         : positive := 16;
      testPrescalerBitNb     : positive := 10;
      angleBitNb             : positive := 4;
      hwOrientationBitNb     : positive := 3;
      baseAddress            : natural  := 0;
      orientationBaseAddress : natural  := 8;
      testBitNb              : positive := 8
   );
   PORT (
      clock      : IN     std_ulogic ;
      reset      : IN     std_ulogic ;
      sClIn      : IN     std_uLogic ;
      sDaIn      : IN     std_uLogic ;
      stepperEnd : IN     std_ulogic ;
      testMode   : IN     std_ulogic ;
      coil1      : OUT    std_ulogic ;
      coil2      : OUT    std_ulogic ;
      coil3      : OUT    std_ulogic ;
      coil4      : OUT    std_ulogic ;
      sDaOut     : OUT    std_uLogic ;
      testOut    : OUT    std_ulogic_vector (1 TO testBitNb)
   );
   END COMPONENT;

   -- Optional embedded configurations
   -- pragma synthesis_off
--    FOR ALL : DFF USE ENTITY sequential.DFF;
--    FOR ALL : bufferUlogic USE ENTITY gates.bufferUlogic;
--    FOR ALL : inverter USE ENTITY gates.inverter;
--    FOR ALL : logic1 USE ENTITY gates.logic1;
--    FOR ALL : stepperMotorController USE ENTITY StepperMotor.stepperMotorController;
   -- pragma synthesis_on


BEGIN
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 2 eb2
   jtagIo(1) <= '0';
   jtagIo(2) <= '0';
   jtagIo(3) <= '0';
   

   -- HDL Embedded Text Block 3 eb3
   sDa <= '0' when sDaOut = '0'
     else 'Z';
   sDaIn <= sDa;
   

   -- HDL Embedded Text Block 4 eb4
   I_O(5)  <= '0';
   I_O(6)  <= '0';
   I_O(7)  <= '0';
   I_O(8)  <= '0';
   I_O(9)  <= '0';
   I_O(10) <= '0';
   I_O(11) <= testOut(2);


   -- Instance port mappings.
   I4 : bufferUlogic
      GENERIC MAP (
         delay => gateDelay
      )
      PORT MAP (
         in1  => coil1,
         out1 => I_O(1)
      );
   I5 : bufferUlogic
      GENERIC MAP (
         delay => gateDelay
      )
      PORT MAP (
         in1  => coil2,
         out1 => I_O(2)
      );
   I6 : bufferUlogic
      GENERIC MAP (
         delay => gateDelay
      )
      PORT MAP (
         in1  => coil3,
         out1 => I_O(3)
      );
   I7 : bufferUlogic
      GENERIC MAP (
         delay => gateDelay
      )
      PORT MAP (
         in1  => coil4,
         out1 => I_O(4)
      );
   I19 : inverter
      GENERIC MAP (
         delay => 1 ns
      )
      PORT MAP (
         in1  => I_O(13),
         out1 => stepperEnd
      );
   I22 : inverter
      GENERIC MAP (
         delay => 1 ns
      )
      PORT MAP (
         in1  => I_O(12),
         out1 => testMode
      );
   I26 : inverter
      GENERIC MAP (
         delay => 1 ns
      )
      PORT MAP (
         in1  => resetSynch_n,
         out1 => resetSynch
      );
   I27 : inverter
      GENERIC MAP (
         delay => 1 ns
      )
      PORT MAP (
         in1  => reset_n,
         out1 => reset
      );
   I3 : logic1
      PORT MAP (
         logic_1 => logic_1
      );
   I18 : DFF
      GENERIC MAP (
         delay => 1 ns
      )
      PORT MAP (
         CLK => clock,
         CLR => resetSynch,
         D   => stepperEnd,
         Q   => stepperEndSynch
      );
   I20 : DFF
      GENERIC MAP (
         delay => 1 ns
      )
      PORT MAP (
         CLK => clock,
         CLR => resetSynch,
         D   => testMode,
         Q   => testModeSynch
      );
   I21 : DFF
      GENERIC MAP (
         delay => 1 ns
      )
      PORT MAP (
         CLK => clock,
         CLR => reset,
         D   => logic_1,
         Q   => resetSynch_n
      );
   I23 : DFF
      GENERIC MAP (
         delay => 1 ns
      )
      PORT MAP (
         CLK => clock,
         CLR => resetSynch,
         D   => sCl,
         Q   => sClSynch
      );
   I24 : DFF
      GENERIC MAP (
         delay => 1 ns
      )
      PORT MAP (
         CLK => clock,
         CLR => resetSynch,
         D   => sDaIn,
         Q   => sDaInSynch
      );
   I0 : stepperMotorController
      GENERIC MAP (
         i2cBitNb               => i2cBitNb,
         prescalerBitNb         => prescalerBitNb,
         testPrescalerBitNb     => testPrescalerBitNb,
         angleBitNb             => angleBitNb,
         hwOrientationBitNb     => hwOrientationBitNb,
         baseAddress            => baseAddress,
         orientationBaseAddress => orientationBaseAddress,
         testBitNb              => testOutBitNb
      )
      PORT MAP (
         clock      => clock,
         reset      => resetSynch,
         sClIn      => sClSynch,
         sDaIn      => sDaInSynch,
         stepperEnd => stepperEndSynch,
         testMode   => testModeSynch,
         coil1      => coil1,
         coil2      => coil2,
         coil3      => coil3,
         coil4      => coil4,
         sDaOut     => sDaOut,
         testOut    => testOut
      );

END struct;




